﻿using MySql.Data.MySqlClient;
using System;
using System.Data;
using System.Threading;

namespace MySQL_Bug
{
    class Program
    {
        static void Main(string[] args)
        {
            //Fill in server, database, user id, password with your test MySQL database info.
            using (var connection = new MySqlConnection("server=;database=;compress=true;user id=;password=;ignoreprepare=false;characterset=utf8;sslmode=None"))
            {
                connection.Open();
                using (var cmd = new MySqlCommand("SELECT * FROM mysql_bug_test WHERE test_key = @TestKey", connection))
                {
                    cmd.Parameters.AddWithValue("@TestKey", "mykey").MySqlDbType = MySqlDbType.VarChar;
                    //Comment out the line below to stop the bugged behavior.
                    cmd.Prepare();
                    using (var reader = cmd.ExecuteReader(CommandBehavior.SingleRow))
                    {
                        if (reader.HasRows)
                        {
                            reader.Read();
                            if (reader["test_val"] is bool) Console.WriteLine("Correct behavior.");
                            else Console.WriteLine("Bugged behavior.");
                        }
                        else Console.WriteLine("No rows. Check your database (this is not the bugged behavior).");
                    }
                }
            }
            Thread.Sleep(5000);
        }
    }
}